clear all

[filename_,PathName]=uigetfile('*.888','Multiselect','on');
%[FileName,PathName] = uigetfile('*.888','Select the Re-TOF file describing the run'); %Select the TOF file you want to load
if isnumeric(filename_)
    disp('File selection aborted by user')
    return
end

if iscell(filename_)
   FileName=filename_; 
else
   FileName=cellstr(filename_);%in case of one element filename_ has to be converted to a cell
end
for i=1:length(FileName)

close all
max_mass=450; %%should be large e.g., >300
laser_start_frequency=30;
start_temp=5;
tempstep=1;
fileposition=strcat(PathName, FileName{1,i});
fileID = fopen(fileposition);
filecontent = textscan(fileID, '%s','delimiter', '\n');
%fileposition=strcat(PathName, FileName{1,i});
range_string=filecontent{1}{9};
sweeps_string=filecontent{1}{12};
cycle_string=filecontent{1}{15};
bitshift_string=filecontent{1}{19};
range=str2num(range_string(7:end));
cycles=str2num(cycle_string(8:end));
bitshift=str2num(bitshift_string(10));
sweeps=str2num(sweeps_string(10:end));
fclose(fileID);
newfileposition=strcat(fileposition(1:(end-3)),'asc');
binfactor=2;
binwidth=2^bitshift;
time=(1:range)*binwidth;
a=importdata(newfileposition);
data = reshape(a,range,cycles);
designation=FileName{1,i}(1:end-4);
%image(data);
 %d = b*10;
 %image(d);
 %3D data
%save('CO_H2Orich_HigDos_10K_10_49eV.txt','data','-ascii');
c = sum(data,2);
c = smooth(c,5);
%figure, plot(c);
%mass= -.2 + time*5.977e-5 + (time.^2)*4.805e-8 - (time.^3)*3.625e-15;
%mass= 0.733 + time*0.0001438 + (time.^2)*2.552e-08 +(time.^3)*1.372e-12 - (time.^4)*3.824e-17 + (time.^5)*5.042e-22 - (time.^6)*2.555e-27;
%mass= 1.733 + time*0.0001238 + (time.^2)*2.552e-08 +(time.^3)*1.372e-12 - (time.^4)*3.824e-17 + (time.^5)*5.042e-22 - (time.^6)*2.555e-27;
%mass= -9.761 + time*0.006042 - (time.^2)*9.982e-07 + (time.^3)*8.82e-11 - (time.^4)*4.205e-15 + (time.^5)*1.196e-19 - (time.^6)*2.016e-24 + (time.^7)*1.85e-29 - (time.^8)*7.219e-35;
%mass= 0.0 + time*0.0001438 + (time.^2)*2.552e-08 +(time.^3)*1.372e-12 - (time.^4)*3.824e-17 + (time.^5)*5.042e-22 - (time.^6)*2.555e-27;
%mass = 0.022153 + time.* 6.5168e-5 + time.^2 * 4.79259e-8 %befor 18
%mass = 0.021657 + time.* 6.4561e-5 + time.^2 * 4.81148e-8 %befor 31
%mass = 0.022153 + time.* 6.5167e-5 + time.^2 * 4.79261e-8 %befor 58
%mass = 0.022102 + time.* 6.5105e-5 + time.^2 * 4.79455e-8 %befor 75
%mass = 0.022204 + time.* 6.523e-5 + time.^2 * 4.79067e-8 %befor 98
%mass = 0.022244 + time.* 6.5278e-5 + time.^2 * 4.78916e-8 %befor 110
%mass = 0.022143 + time.* 6.5155e-5 + time.^2 * 4.79298e-8 %befor 124
%mass = 0.022112 + time.* 6.5118e-5 + time.^2 * 4.79414e-8 %befor 140
%mass = 0.02218 + time.* 6.5201e-5 + time.^2 * 4.79156e-8 %befor 167
%mass = 0.022206 + time.* 6.523e-5 + time.^2 * 4.79061e-8 %befor 182
%mass = 0.022247 + time.* 6.5281e-5 + time.^2 * 4.78906e-8 %befor 206
%mass = 0.022182 + time.* 6.5203e-5 + time.^2 * 4.79149e-8 %befor 220
%mass = 0.022164 + time.* 6.5181e-5 + time.^2 * 4.79219e-8 %befor 236
%mass = 0.022382 + time.* 6.5445e-5 + time.^2 * 4.78396e-8 %befor 256
%mass = 0.022337 + time.* 6.5391e-5 + time.^2 * 4.78564e-8 %befor 284
mass = 0.022502 + time.* 6.5589e-5 + time.^2 * 4.77946e-8 %befor 354
%mass = 0.022613 + time.* 6.5722e-5 + time.^2 * 4.77528e-8 %befor 428



findpeaks(c,'MinPeakDistance',35,'MinPeakProminence',10)
[~,Peaks]=findpeaks(c,'MinPeakDistance',35,'MinPeakProminence',10);
%figure
%plot(mass,c)
%masses(1,2)=input('Enter lower mass');
%masses(1,1)=input('Enter channel for lower mass');
%masses(2,2)=input('Enter intermediate mass');
%masses(2,1)=input('Enter channel for intermediate mass');
%masses(3,2)=input('Enter higher mass');
%masses(3,1)=input('Enter channel for higher mass');
[~,Reference]=max(c(1500:end));
mass_ref=mass(Reference+1499);
mass_ref=round(mass_ref);
disp 'I am guessing your maximum peak is at mass', disp(mass_ref), 
%mass_corr=input('is that correct? y/n','s');
%if mass_corr=='y'
%mass_correction=mass_ref;
%else if mass_corr=='n'
%        mass_correction=input('please enter correct mass');
%    else
%        disp 'error, invalid input'   
%        return
%    end
%end
Peaks_mass=mass(Peaks)';
Peaks_mass=round(Peaks_mass);
%Peaks_mass(1)=2;
TIME=time(Peaks);
%fo = fitoptions('StartPoint',[2.555e-27,5.042e-22,3.824e-17,1.372e-12,2.552e-08,0.0001438,0.2733]);

%used for 10.49 eV  for   MPA
%inde=      [2,    6,     7,     8,     13,    19,    27,    30,    33,    37,    47,    50,    53,    54,    58,    60,    61];
%TIME=      [3888, 18700, 24712, 34108, 38872, 44548, 48020, 50396, 53360, 58356, 60956, 67080, 69496, 71272, 75880, 85376, 93984];
%Peaks_mass=[1,    18,    31,    58,    75,    98,    113,   126,   139,   166,   181,   219,   235,   247,   280,   354,   428]';

%TIME=[3888, 18700, 24712, 34108, 37216, 42652, 45236, 47500, 48020, 50184, 53588, 60956, 67080, 69486, 72468, 76352, 85376, 93984];
%Peaks_mass=[3, 18, 31, 57, 68, 88, 100, 110, 111, 123, 140, 180, 217, 232, 250, 273, 318, 331]';




f=fit(TIME',Peaks_mass,'poly8');

figure
plot(TIME,Peaks_mass,'o')
hold on
%plot(time,f.p9 + time.*f.p8 + (time.^2).*f.p7 +(time.^3).*f.p6 + (time.^4).*f.p5 + (time.^5).*f.p4 + (time.^6).*f.p3 + (time.^7).* f.p2 + (time.^8).* f.p1 )
hold off
%mass= -0.2733 + time*0.0001438 + (time.^2)*2.552e-08 +(time.^3)*1.372e-12 - (time.^4)*3.824e-17 + (time.^5)*5.042e-22 - (time.^6)*2.555e-27;
%mass= 1.933 + time*0.0001238 + (time.^2)*2.552e-08 +(time.^3)*1.372e-12 - (time.^4)*3.824e-17 + (time.^5)*5.042e-22 - (time.^6)*2.555e-27;
figure(8888)
plot(mass,c)
mass= f.p9 + time.*f.p8 + (time.^2).*f.p7 +(time.^3).*f.p6 + (time.^4).*f.p5 + (time.^5).*f.p4 + (time.^6).*f.p3 + (time.^7).* f.p2 + (time.^8).* f.p1 ;


hold on
plot(mass,c)
min_mass=1;
hold off
axis([min_mass max_mass 0 inf])

ind_newmass=mass < max_mass;
new_data=data(ind_newmass,:);
new_mass=mass(ind_newmass);
counts=new_data;
save(1,'counts','-ascii');
mass=new_mass;
%we have quiet a small binwidth so we want to rebin the whole thing...
%[bin_data_row1, bin_mass]=binning_1d(new_mass, new_data(:,1), ceil(size(new_data, 1)/binfactor));
%bin_data=zeros(size(bin_data_row1,2), size(new_data,2));
%bin_data(:,1)=bin_data_row1;
%for kk = 2:size(new_data,2);
%	[bin_data(:,kk), bin_mass]=binning_1d(new_mass, new_data(:,kk), ceil(size(new_data, 1)/binfactor));
%end;
%output:
%binned_counts=bin_data;
%counts=binned_counts;
%binned_mass=bin_mass;
%rawdata=data;
%mass=binned_mass;
figure
Sum_mass_intensity=sum(counts,2);
Sum_mass=mass';
plot(mass,sum(counts,2))
axis([-10 max_mass 0 inf])

% figure %%%plot time vs signal
% plot(time,sum(counts,2))


% now we make a temperature scale which translates cycle numbers to a temperature scale
%this is how many seconds a cycle takes:
cycletime=sweeps/laser_start_frequency;
time_according_to_cyclenumber=(0:size(new_data,2)-1)*cycletime;
kelvin_per_sec=tempstep/60;
temperature=start_temp+time_according_to_cyclenumber*kelvin_per_sec;






number_specs=max_mass-min_mass;
mass_ind = (mass > min_mass & mass < max_mass);
toplot=smooth(sum(counts,2),10);
%semilogy (mass(mass_ind), toplot(mass_ind))  ;
peakwidth=0.8; % changes the range around which mass center the passes are integrated. (should be decreased if non-integer m/c is expected)
min_set=10; % sets a minimum threshold to plot 
cycletime=sweeps/laser_start_frequency;
time_according_to_cyclenumber=(0:size(new_data,2)-1)*cycletime;
kelvin_per_sec=tempstep/60;
temp=start_temp+time_according_to_cyclenumber*kelvin_per_sec;
name=strcat(designation,'_all_masses.txt');
for kk = min_mass:max_mass
	mass_ind = (mass > kk - peakwidth/2 & mass < kk + peakwidth/2);
 	matri(:,kk)=smooth(sum(counts(mass_ind,:),1),5);
     %matri(:,kk)=sum(counts(mass_ind,:),1);
     	
end
save(name,'matri','-ascii');
end



% figure
% plot(mass,sum(counts,2))
% axis([-10 max_mass 0 inf])

% figure
% plot(time,sum(counts,2))

