clear global
close all

m1 = 43;
m2 = 90;
bin1 = 0;
bin2 = 0;
TestRange = 10;

[FileName,PathName] = uigetfile('*.888','Multiselect','on');
fileposition = strcat(PathName,FileName);
data_import = importdata(fileposition,' ',54);
range = str2num(data_import.textdata{2}(7:end));
cycles = str2num(data_import.textdata{12}(8:end));
BinWidth = 0.8*2^str2num(data_import.textdata{43}(10));
data_raw = reshape(data_import.data,range,cycles);
data_time_integrated = sum(data_raw,2);
ToF = (1:range)*BinWidth;
[~,Peaks] = findpeaks(smooth(data_time_integrated,10),'MinPeakDistance',35,'MinPeakProminence',5);
Peaks = Peaks(3:end);
A = 4.7740e-08;
B = 675.9483;
Mass = A*(ToF+B).^2;

Rounded = round(Mass(Peaks));
index1 = find(Rounded==m1);
index2 = find(Rounded==m2);
if bin1 == 0
    t1 = ToF(Peaks(index1));
else
    t1 = bin1*BinWidth;
end
if bin2 == 0
    t2 = ToF(Peaks(index2));
else
    t2 = bin2*BinWidth;
end
IndexM1 = zeros(1,(2*TestRange+1)^2);
IndexM2 = zeros(1,(2*TestRange+1)^2);
Error = zeros(1,(2*TestRange+1)^2);
n=1;
syms a b

for M1 = (m1-TestRange:m1+TestRange)
     for M2 = (m2-TestRange:m2+TestRange)   
        IndexM1(n) = M1;
        IndexM2(n) = M2;
        [ATest,BTest] = solve(M1 == a*(t1+b)^2, M2 == a*(t2 + b)^2, a > 0, b == sqrt(M1/a)-t1);
        ATest = eval(ATest);
        BTest = eval(BTest);
        if isempty(ATest)
            Error(n) = max(Error);
        else
            PeaksMass = ATest*(Peaks*BinWidth + BTest).^2;
            Error(n) = sum(abs(PeaksMass-round(PeaksMass)));
        end
        n = n+1;
     end
end

OptIndex = find(Error==min(Error));
m1 = IndexM1(OptIndex);
m2 = IndexM2(OptIndex);
[ATest,BTest] = solve(m1 == a*(t1+b)^2, m2 == a*(t2 + b)^2, a > 0, b == sqrt(m1/a)-t1);
Mass = ATest*(ToF+BTest).^2;
plot(Mass,data_time_integrated)
