clear all

[filename_,PathName]=uigetfile('*.mp','Multiselect','on');
%[FileName,PathName] = uigetfile('*.888','Select the Re-TOF file describing the run'); %Select the TOF file you want to load
if isnumeric(filename_)
    disp('File selection aborted by user')
    return
end

if iscell(filename_)
   FileName=filename_; 
else
   FileName=cellstr(filename_);%in case of one element filename_ has to be converted to a cell
end
for i=1:length(FileName)

close all
max_mass=300;
laser_start_frequency=30;
start_temp=5;
tempstep=1.0;
fileposition=strcat(PathName, FileName{1,i});
a=importdata(fileposition,' ',54);
range_string=a.textdata{2};
sweeps_string=a.textdata{7};
cycle_string=a.textdata{12};
bitshift_string=a.textdata{43};
range=str2num(range_string(7:end));
cycles=str2num(cycle_string(8:end));
bitshift=str2num(bitshift_string(10));
sweeps=str2num(sweeps_string(10:end));
% fclose(fileID);
% newfileposition=strcat(fileposition(1:(end-3)),'asc');
%binfactor=2;
binwidth=0.8*2^bitshift;

time=(0:range-1)*binwidth;
a=importdata(fileposition,' ',54);
data = reshape(a.data,range,cycles);
%data(:,105)=data(:,104);
designation=FileName{1,i}(1:end-4);
%image(data);
 %d = b*10;
 %image(d);
 %3D data
%save('CO_H2Orich_HigDos_10K_10_49eV.txt','data','-ascii');
c=sum(data,2);
c=smooth(c,5);
%figure, plot(c);
mass= 1.004*(0.05746885+ time*5.668314e-5+(time.^2)*4.758394e-8);


% use Joshua fitting parameters
%%%% new volatged
% A=1.03631*10^-7;
% B=-2291.32699;
% C=1.93671;
% D=3.22222;


%%%% old volatge
% A=5.06218*10^-8;
% B=910.41493;
% C=1.99417;
% D=-0.95055;

% mass1= 1.000*(A*(time+B).^C+D);
% mass=real(mass1);
% 




%%%jia_fit_tof: TOF_jia_fit_c2h2_nh3_1127

% % % % % used for 10.49 eV  for 8, 9 reactions
%  TIME=[3915,18240, 18800, 24423, 29380,31730, 32370, 36830, 37385,39790, 43508, 45145, 49100, 51358, 54320]; %% unit is ns
%  Peaks_mass=[1, 17,18, 30, 43, 50, 52, 67, 69, 78,93, 100, 118, 129, 144 ]';

% % % % % % %%%used for 9.8, 8.81,8.61 eV  for 8, 9 reactions
% % % TIME=[18812, 24463, 29408, 32408, 34263, 36868, 37428,39831, 43555, 45180, 49145, 5142, 54345];
% % %  Peaks_mass=[18, 30, 43, 52, 58, 67, 69, 78,93, 100, 118, 129, 144 ]';
% % % 

% 
% f=fit(TIME',Peaks_mass,'poly8');
% 
% mass= f.p9 + time.*f.p8 + (time.^2).*f.p7 +(time.^3).*f.p6 + (time.^4).*f.p5 + (time.^5).*f.p4 + (time.^6).*f.p3 + (time.^7).* f.p2 + (time.^8).* f.p1 ;

Intensiy=sum(data,2);
figure(888)


plot(mass,Intensiy)
min_mass=1;
axis([min_mass 500 0 inf])
mass_x=mass';
Intensiy_y=Intensiy;
xlabel('m/z')
ylabel('Intensity')

aExportData = [mass_x Intensiy_y];

end



